HDU 2899 Strange fuction

Now, here is a fuction:
F(x) = 6 * x^7+8*x^6+7*x^3+5*x^2-y*x (0 <= x <=100)
Can you find the minimum value when x is between 0 and 100.

Input
The first line of the input contains an integer T(1<=T<=100) which means the number of test cases. Then T lines follow, each line has only one real numbers Y.(0 < Y <1e10)

Output
Just the minimum value (accurate up to 4 decimal places),when x is between 0 and 100.

Sample Input
2
100
200

Sample Output
-74.4291
-178.8534

题意,一个函数,给y值,给x值范围,求函数最小值。

思路大致是,求一阶导数,得到F’(x)=42x^6+48x^5+21x^2+10-y。继续求二阶导,得到F”(x)=252x^5+240x^4+42x^+10。因为0<=x<=100,所以二阶导大于等于零,所以x>0时,一阶导单调增,因为-y<0,42x^6+48x^5+21x^2+10>0,所以一阶导等于零时,原函数取最小值。因为y值给定,故用x的范围作为二分的上下界。对于每个mid,求其一阶导是否为0。

遇到的问题,eps的问题,在二分判断le和ri的时候,发现le小于ri+eps不可行,但是le小于ri-eps,ri>le+eps,(ri-le)>eps,(ri-le)>1e-10这些却可行。发现自己对eps理解不深刻。eps存在的目的,是为了帮助浮点数判断大小,两个浮点数a==b,要通过a-b小于eps要实现。

代码如下

#include<stdio.h>
#include<iostream>
#include<string>
#include<cstring>
#include<cmath>
#include<algorithm>
using namespace std;
int T;
double x,y;
const double eps=1e-8;
double fx(double x){
    return 6*pow(x,7)+8*pow(x,6)+7*pow(x,3)+5*pow(x,2)-y*x;
}
double fxx(double x){
    return 42*pow(x,6)+48*pow(x,5)+21*pow(x,2)+10*x-y;
}
int main(){
    scanf("%d",&T);
    while(T--){
        scanf("%lf",&y);
        double le=0.0,ri=100.0,mid;
        while(ri>le+eps){  //
            mid=(le+ri)/2.0;
            if(fxx(mid)>0)
                ri=mid;
            else
                le=mid;
        }
        printf("%.4lf\n",fx(mid));
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值